

%define avcmajor 60
%define avclibname %mklibname avcodec %avcmajor
%define develname %mklibname %name -d
%define staticname %mklibname %name -s -d

%define avfmajor 60
%define avflibname %mklibname avformat %avfmajor

%define postprocmajor 57
%define postproclibname %mklibname postproc %postprocmajor

%define avumajor 58
%define avulibname %mklibname avutil %avumajor

%define avrmajor		4
%define avrlibname		%mklibname avresample %avrmajor

%define swsmajor 7
%define swslibname %mklibname swscaler %swsmajor

%define filtermajor 9
%define filterlibname %mklibname avfilter %filtermajor

%define swresamplemajor 4
%define swresamplelibname %mklibname swresample %swresamplemajor

Name: 	 	ffmpeg
Version: 	6.1.1
Release: 	%mkrel 1
Summary: 	Hyper fast MPEG1/MPEG4/H263/RV and AC3/MPEG audio encoder
URL:		http://ffmpeg.org/
Source0: 	http://ffmpeg.org/releases/%{name}-%{version}.tar.xz
License: 	GPLv3+
Group: 	 	Video

# Fixes for reduced codec selection on free build
Patch1:         ffmpeg-codec-choice.patch
# Allow to build with fdk-aac-free
# See https://bugzilla.redhat.com/show_bug.cgi?id=1501522#c112
Patch2:         ffmpeg-allow-fdk-aac-free.patch
# Drop openh264 runtime version checks
# https://patchwork.ffmpeg.org/project/ffmpeg/list/?series=10211
Patch4:         0001-lavc-libopenh264-Drop-openh264-runtime-version-check.patch
Patch5:         ffmpeg-c99.patch
# Fix build with gcc14 (-Wint-conversion, -Wincompatible-pointer-types)
Patch6:         ffmpeg-gcc14.patch

# Set up dlopen for openh264
Patch1001:      ffmpeg-dlopen-openh264.patch

# Add first_dts getter to libavformat for Chromium
# See: https://bugzilla.redhat.com/show_bug.cgi?id=2240127
# Reference: https://crbug.com/1306560
Patch1002:      ffmpeg-chromium.patch
#---------------------------------------------

BuildRequires:	yasm
BuildRequires: frei0r-plugins-devel
BuildRequires: libtheora-devel
BuildRequires: texi2html
BuildRequires: x264-devel
BuildRequires:	SDL-devel
BuildRequires:	opencl-devel
BuildRequires: lib64SDL-devel
BuildRequires: lib64alsa2-devel
BuildRequires: lib64ass-devel
BuildRequires: lib64bzip2-devel
BuildRequires: lib64cdio-devel
BuildRequires: lib64celt-devel 
BuildRequires: lib64crystalhd-devel
BuildRequires: lib64dc1394-devel
BuildRequires: lib64dirac-devel
BuildRequires: lib64faac-devel
BuildRequires: lib64freetype6-devel
BuildRequires: lib64gmp-devel
BuildRequires: lib64gnutls-devel
BuildRequires: lib64gsm-devel
BuildRequires: lib64jack-devel
BuildRequires: lib64jpeg-devel
BuildRequires: lib64lame-devel
BuildRequires: lib64lzo-devel
BuildRequires: lib64modplug-devel
BuildRequires: lib64nettle-devel
BuildRequires: lib64nut-devel
BuildRequires: lib64ogg-devel
BuildRequires: lib64opencore-amrnb-devel
BuildRequires: lib64opencore-amrwb-devel
BuildRequires: lib64openjpeg-devel
BuildRequires: lib64opus-devel
BuildRequires: lib64cdio-paranoia-devel
BuildRequires: lib64png-devel
BuildRequires: lib64pulseaudio-devel
BuildRequires: lib64rtmp-devel
BuildRequires: lib64schroedinger-devel
BuildRequires: lib64speex1-devel
BuildRequires: lib64twolame-devel
BuildRequires: lib64v4l-devel
BuildRequires: lib64va-devel
BuildRequires: lib64vdpau-devel
BuildRequires: lib64vo-aacenc-devel
BuildRequires: lib64vo-amrwbenc-devel
BuildRequires: lib64vorbis0-devel
BuildRequires: lib64vpx-devel
BuildRequires: lib64x11-devel
BuildRequires: lib64xavs-devel
BuildRequires: lib64xext-devel
BuildRequires: lib64xfixes-devel
BuildRequires: lib64xv-devel
BuildRequires: lib64xvid4-devel
BuildRequires: lib64xvmc-devel
BuildRequires: lib64x265-devel
BuildRequires: lib64resample-devel
BuildRequires: lib64webp-devel
BuildRequires: fdk-aac-devel
BuildRequires: ffnvcodec-devel
BuildRequires: lib64aom-devel
BuildRequires: lib64dav1d-devel
BuildRequires: lib64zvbi-devel
BuildRequires: lib64ilbc-devel
BuildRequires: lib64mfx-devel

BuildRequires: ladspa-devel
#---------------------------------------------
Requires:	%postproclibname = %version-%release
Requires:	%avclibname = %version-%release
Requires:	%avflibname = %version-%release
Requires:	%avulibname = %version-%release
Requires:	%filterlibname = %version-%release
Requires:	%{swslibname} = %{version}-%release
Requires:	%swresamplelibname = %{version}-%release
#---------------------------------------------

%description
ffmpeg is a hyper fast realtime audio/video encoder, a streaming server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

%package -n %{avclibname}
Group:          System/Libraries
Summary:        Shared library part of ffmpeg
Provides:       libffmpeg = %{version}-%{release}

%description -n %{avclibname}
ffmpeg is a hyper fast realtime audio/video encoder, a streaming server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

Install libffmpeg if you want to encode multimedia streams.

%package -n %{postproclibname}
Group:          System/Libraries
Summary:        Shared library part of ffmpeg

%description -n %{postproclibname}
ffmpeg is a hyper fast realtime audio/video encoder, a streaming server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

Install libffmpeg if you want to encode multimedia streams.

%package -n %{avflibname}
Group:          System/Libraries
Summary:        Shared library part of ffmpeg

%description -n %{avflibname}
ffmpeg is a hyper fast realtime audio/video encoder, a streaming server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

Install libffmpeg if you want to encode multimedia streams.

%package -n %{avulibname}
Group:          System/Libraries
Summary:        Shared library part of ffmpeg

%description -n %{avulibname}
ffmpeg is a hyper fast realtime audio/video encoder, a streaming server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

Install libffmpeg if you want to encode multimedia streams.

%package -n %{swslibname}
Group:          System/Libraries
Summary:        Shared library part of ffmpeg

%description -n %{swslibname}
ffmpeg is a hyper fast realtime audio/video encoder, a streaming server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

Install libffmpeg if you want to encode multimedia streams.

%package -n %{filterlibname}
Group:          System/Libraries
Summary:        Shared library part of ffmpeg

%description -n %{filterlibname}
ffmpeg is a hyper fast realtime audio/video encoder, a streaming server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

Install libffmpeg if you want to encode multimedia streams.

%package -n %{swresamplelibname}
Group:		System/Libraries
Summary:	Shared library part of ffmpeg

%description -n %{swresamplelibname}
ffmpeg is a hyper fast realtime audio/video encoder, a streaming server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

Install libffmpeg if you want to encode multimedia streams.

%package -n %develname
Group:          Development/Libraries
Summary:        Header files for the ffmpeg codec library
Requires:   %{avclibname} = %{version}-%release
Requires:   %{avflibname} = %{version}-%release
Requires:   %{avulibname} = %{version}-%release
Requires:   %{postproclibname} = %{version}-%release
Requires:   %{swslibname} = %{version}-%release
Requires:	%{filterlibname} = %{version}-%release
Requires:	%{swresamplelibname} = %{version}-%release
Provides:   libffmpeg-devel = %{version}-%{release}
Provides:	ffmpeg-devel = %{version}-%{release}

%description -n %develname
ffmpeg is a hyper fast realtime audio/video encoder, a streaming server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

Install libffmpeg-devel if you want to compile apps with ffmpeg support.

%package -n %staticname
Group:          Development/Libraries
Summary:        Static library for the ffmpeg codec library
Requires:       %develname = %{version}-%release
Provides:       libffmpeg-static-devel = %{version}-%{release}

%description -n %staticname
ffmpeg is a hyper fast realtime audio/video encoder, a streaming server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

Install libffmpeg-devel if you want to compile apps with ffmpeg support.

%prep
%setup -q -n %{name}-%version
%autopatch -p1


%build
export LDFLAGS="-L/usr/lib64/libglvnd/ $LDFLAGS"
export CFLAGS="%{optflags} -fPIC"
export LDFLAGS="%{ldflags}"


###

./configure --prefix=%{_prefix} \
	--enable-shared \
	--enable-pic \
	--libdir=%{_libdir} \
	--shlibdir=%{_libdir} \
	--incdir=%{_includedir} \
	--extra-cflags="-I/usr/include/nvenc" \
	--disable-stripping \
	--enable-postproc \
	--enable-gpl \
	--enable-pthreads \
	--enable-libtheora \
	--enable-libvorbis \
	--disable-encoder=vorbis \
	--enable-libvpx \
	--enable-runtime-cpudetect \
	--enable-libaom \
	--enable-libdc1394 \
	--enable-librtmp \
	--enable-libspeex \
	--enable-libfreetype \
	--enable-libgsm \
	--enable-libcelt \
	--enable-libopus \
	--disable-libopencv \
	--enable-libopenjpeg \
	--enable-libaom \
 	--enable-libvidstab \
	--enable-libtwolame \
	--enable-libxavs \
	--enable-frei0r \
	--enable-libmodplug \
	--enable-libass \
	--enable-gnutls \
	--enable-libcdio \
	--enable-libmfx \
	--enable-libpulse \
	--enable-libv4l2 \
	--enable-opencl \
	--enable-libmp3lame \
	--enable-sndio \
	--enable-libdav1d \
	--enable-libopencore-amrnb \
	--enable-libopencore-amrwb \
	--enable-version3 \
	--enable-libx264 \
	--enable-libx265 \
	--enable-libvo-amrwbenc \
	--enable-libxvid \
	--enable-libjxl \
	--enable-decoder=atrac3 \
	--enable-decoder=atrac3p \
	--enable-libwebp \
	--enable-libfdk-aac \
	--enable-nonfree \
	--enable-cuda \
	--enable-cuvid \
	--enable-nvenc \
	--enable-libzvbi \
	--extra-cflags=-I/usr/local/cuda/include \
	--extra-ldflags=-L/usr/local/cuda/lib64 \
	--enable-libsoxr \
	--enable-ladspa \
	--enable-lcms2 \
	--enable-libcodec2 \
	--enable-libass \
  --enable-libdav1d \
  --enable-libdc1394 \
  --enable-libgsm \
  --enable-libiec61883 \
  --enable-libilbc \
  --enable-libjack \
  --enable-libjxl 

%make
make tools/qt-faststart

%install
rm -rf %buildroot
%makeinstall_std SRC_PATH=`pwd`

rm -rf %buildroot/%{_datadir}/doc

%files
%{_bindir}/*
%{_mandir}/man1/*
%{_datadir}/ffmpeg


%files -n %{avclibname}
%{_libdir}/libavcodec.so.%{avcmajor}*

%files -n %postproclibname
%{_libdir}/libpostproc.so.%{postprocmajor}*

%files -n %{avflibname}
%{_libdir}/libavformat.so.%{avfmajor}*
%{_libdir}/libavdevice.so.%{avfmajor}*

%files -n %{avulibname}
%{_libdir}/libavutil.so.%{avumajor}*

%files -n %{swslibname}
%{_libdir}/libswscale.so.%{swsmajor}*

%files -n %{filterlibname}
%{_libdir}/libavfilter.so.%{filtermajor}*

%files -n %{swresamplelibname}
%{_libdir}/libswresample.so.%{swresamplemajor}*

%files -n %develname
%{_includedir}/libavcodec
%{_includedir}/libavdevice
%{_includedir}/libavfilter
%{_includedir}/libavformat
%{_includedir}/libavutil
%{_includedir}/libpostproc
%{_includedir}/libswscale
%{_includedir}/libswresample
%{_libdir}/libavcodec.so
%{_libdir}/libavdevice.so
%{_libdir}/libavformat.so
%{_libdir}/libavfilter.so
%{_libdir}/libavutil.so
%{_libdir}/libpostproc.so
%{_libdir}/libswscale.so
%{_libdir}/libswresample.so
%{_libdir}/pkgconfig/libswscale.pc
%{_libdir}/pkgconfig/libavcodec.pc
%{_libdir}/pkgconfig/libavdevice.pc
%{_libdir}/pkgconfig/libavfilter.pc
%{_libdir}/pkgconfig/libavformat.pc
%{_libdir}/pkgconfig/libavutil.pc
%{_libdir}/pkgconfig/libpostproc.pc
%{_libdir}/pkgconfig/libswresample.pc
%{_mandir}/man3/lib*.3*

%files -n %staticname
%{_libdir}/*.a


%changelog
* Tue Oct 10 2023 tex - 5.1.3-2pclos2023
- rebuild against updates

* Thu Mar 09 2023 onkelho <oh.quait at gmail.com> - 5.1.3-1pclos2023
- new version released as bugfix-release
- avresample The resample filter based upon this library has been removed as well.
- add # Upstream patches # CVE-2022-3965
- Add patch from SuSE to fix CVE-2022-3964 (mga#31175)
- Build with jpeg-xl support
- Add patch to build Chromium with unbundled ffmpeg system lib
- commented out 2#piece off patch (kodi should call avformat_flush instead of av_read_frame_flush_mga_kodi_mod)
- remove libavresample (deprecated in favor of libswresample in ffmpeg 4.0, removed in 5.0)
- unknown option --enable-libfaac \
	
* Wed Feb 01 2023 tex - 4.4.1-2pclos2023
- rebuild against updates

* Sun Oct 24 2021 tex - 4.4.1-1pclos2021
- new version

